summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorJoshua Nichols <nichoj@gentoo.org>2006-06-24 18:36:59 +0000
committerJoshua Nichols <nichoj@gentoo.org>2006-06-24 18:36:59 +0000
commit523b8e8c19bde09b72a90175f9086f3c92e7507f (patch)
tree68074cc21c9262f3a8d48c17e96df86e5ad482e9
parentStable on SPARC wrt bug #137392. (diff)
downloadhistorical-523b8e8c19bde09b72a90175f9086f3c92e7507f.tar.gz
historical-523b8e8c19bde09b72a90175f9086f3c92e7507f.tar.bz2
historical-523b8e8c19bde09b72a90175f9086f3c92e7507f.zip
Adding new Java eclasses, and updating old ones.
-rw-r--r--eclass/java-ant-2.eclass155
-rw-r--r--eclass/java-pkg-2.eclass85
-rw-r--r--eclass/java-pkg-opt-2.eclass75
-rw-r--r--eclass/java-pkg.eclass67
-rw-r--r--eclass/java-utils-2.eclass1747
-rw-r--r--eclass/java-utils.eclass6
-rw-r--r--eclass/java-vm-2.eclass149
-rw-r--r--eclass/java.eclass15
8 files changed, 2281 insertions, 18 deletions
diff --git a/eclass/java-ant-2.eclass b/eclass/java-ant-2.eclass
new file mode 100644
index 000000000000..ad923182b1f8
--- /dev/null
+++ b/eclass/java-ant-2.eclass
@@ -0,0 +1,155 @@
+# eclass for ant based Java packages
+#
+# Copyright (c) 2004-2005, Thomas Matthijs <axxo@gentoo.org>
+# Copyright (c) 2004-2005, Gentoo Foundation
+#
+# Licensed under the GNU General Public License, v2
+#
+
+inherit java-utils-2
+
+# This eclass provides functionality for Java packages which use
+# ant to build. In particular, it will attempt to fix build.xml files, so that
+# they use the appropriate 'target' and 'source' attributes.
+
+# Only exports src_unpack
+EXPORT_FUNCTIONS src_unpack
+
+# We need some tools from java-toolkit
+DEPEND=">=dev-java/javatoolkit-0.1.5"
+
+# ------------------------------------------------------------------------------
+# @global JAVA_ANT_BSFIX
+#
+# Should we attempt to 'fix' ant build files to include the source/target
+# attributes when calling javac?
+#
+# default: on
+# ------------------------------------------------------------------------------
+JAVA_ANT_BSFIX=${JAVA_PKG_BSFIX:="on"}
+
+# ------------------------------------------------------------------------------
+# @global JAVA_ANT_BSFIX_ALL
+#
+# If we're fixing build files, should we try to fix all the ones we can find?
+#
+# default: yes
+# ------------------------------------------------------------------------------
+JAVA_ANT_BSFIX_ALL=${JAVA_PKG_BSFIX_ALL:="yes"}
+
+# ------------------------------------------------------------------------------
+# @global JAVA_ANT_BSFIX_NAME
+#
+# Filename of build files to fix/search for
+#
+# default: build.xml
+# ------------------------------------------------------------------------------
+JAVA_ANT_BSFIX_NAME=${JAVA_PKG_BSFIX_NAME:="build.xml"}
+
+# ------------------------------------------------------------------------------
+# @global JAVA_ANT_BSFIX_TARGETS_TAGS
+#
+# Targets to fix the 'source' attribute in
+#
+# default: javac xjavac javac.preset
+# ------------------------------------------------------------------------------
+JAVA_ANT_BSFIX_TARGET_TAGS=${JAVA_PKG_BSFIX_TARGET_TAGS:="javac xjavac javac.preset"}
+
+# ------------------------------------------------------------------------------
+# @global JAVA_ANT_BSFIX_SOURCE_TAGS
+#
+# Targets to fix the 'target' attribute in
+#
+# default: javacdoc javac xjavac javac.preset
+# ------------------------------------------------------------------------------
+JAVA_ANT_BSFIX_SOURCE_TAGS=${JAVA_PKG_BSFIX_SOURCE_TAGS:="javadoc javac xjavac javac.preset"}
+
+# ------------------------------------------------------------------------------
+# @public java-ant_src_unpack
+#
+# Unpacks the source, and attempts to fix build files.
+# ------------------------------------------------------------------------------
+java-ant-2_src_unpack() {
+ ant_src_unpack
+ java-ant_bsfix
+}
+
+# ------------------------------------------------------------------------------
+# @private ant_src_unpack
+#
+# Helper function which does the actual unpacking
+# ------------------------------------------------------------------------------
+# TODO maybe use base.eclass for some patching love?
+ant_src_unpack() {
+ debug-print-function ${FUNCNAME} $*
+ if [[ -n "${A}" ]]; then
+ unpack ${A}
+ fi
+}
+
+# ------------------------------------------------------------------------------
+# @private java-ant_bsfix
+#
+# Attempts to fix build files. The following variables will affect its behavior
+# as listed above:
+# JAVA_PKG_BSFIX
+# JAVA_PKG_BSFIX_ALL
+# JAVA_PKG_BSFIX_NAME,
+# JAVA_PKG_BSFIX_SOURCE_TAGS
+# JAVA_PKG_BSFIX_TARGET_TAGS)
+# ------------------------------------------------------------------------------
+java-ant_bsfix() {
+ debug-print-function ${FUNCNAME} $*
+
+ [[ "${JAVA_PKG_BSFIX}" != "on" ]] && return
+ if ! java-pkg_needs-vm; then
+ echo "QA Notice: Package is using java-ant, but doesn't depend on a Java VM"
+ fi
+
+ cd "${S}"
+
+ local find_args="-type f"
+ if [[ "${JAVA_PKG_BSFIX_ALL}" == "yes" ]]; then
+ find_args="${find_args} -name ${JAVA_PKG_BSFIX_NAME// / -o -name }"
+ else
+ find_args="${find_args} -maxdepth 1 -name ${JAVA_PKG_BSFIX_NAME// / -o -name } "
+ fi
+
+ local i=0
+ local -a bsfix_these
+ while read line; do
+ [[ -z ${line} ]] && continue
+ bsfix_these[${i}]="${line}"
+ let i+=1
+ done <<-EOF
+ $(find ${find_args})
+ EOF
+
+ local want_source="$(java-pkg_get-source)"
+ local want_target="$(java-pkg_get-target)"
+
+ debug-print "bsfix: target: ${want_target} source: ${want_source}"
+
+ if [ -z "${want_source}" -o -z "${want_target}" ]; then
+ eerror "Could not find valid -source/-target values"
+ eerror "Please file a bug about this on bugs.gentoo.org"
+ die "Could not find valid -source/-target values"
+ else
+ for (( i = 0 ; i < ${#bsfix_these[@]} ; i++ )); do
+ local file="${bsfix_these[${i}]}"
+ echo "Rewriting ${file}"
+ debug-print "bsfix: ${file}"
+
+ cp "${file}" "${file}.orig" || die "failed to copy ${file}"
+
+ chmod u+w "${file}"
+
+ xml-rewrite.py -f "${file}" -c -e ${JAVA_PKG_BSFIX_SOURCE_TAGS// / -e } -a source -v ${want_source} || die "xml-rewrite failed: ${file}"
+ xml-rewrite.py -f "${file}" -c -e ${JAVA_PKG_BSFIX_TARGET_TAGS// / -e } -a target -v ${want_target} || die "xml-rewrite failed: ${file}"
+
+ if [[ -n "${JAVA_PKG_DEBUG}" ]]; then
+ diff -NurbB "${file}.orig" "${file}"
+ fi
+ done
+ fi
+}
diff --git a/eclass/java-pkg-2.eclass b/eclass/java-pkg-2.eclass
new file mode 100644
index 000000000000..cbaac83b4b3b
--- /dev/null
+++ b/eclass/java-pkg-2.eclass
@@ -0,0 +1,85 @@
+# Eclass for Java packages
+#
+# Copyright (c) 2004-2005, Thomas Matthijs <axxo@gentoo.org>
+# Copyright (c) 2004-2005, Gentoo Foundation
+#
+# Licensed under the GNU General Public License, v2
+#
+
+inherit java-utils-2
+
+# -----------------------------------------------------------------------------
+# @eclass-begin
+# @eclass-summary Eclass for Java Packages
+#
+# This eclass should be inherited for pure Java packages, or by packages which
+# need to use Java.
+# -----------------------------------------------------------------------------
+
+# ------------------------------------------------------------------------------
+# @depend
+#
+# Java packages need java-config, and a fairly new release of Portage.
+#
+# JAVA_PKG_E_DEPEND is defined in java-utils.eclass.
+# ------------------------------------------------------------------------------
+DEPEND="${JAVA_PKG_E_DEPEND}"
+
+# ------------------------------------------------------------------------------
+# @rdepend
+#
+# Nothing special for RDEPEND... just the same as DEPEND.
+# ------------------------------------------------------------------------------
+RDEPEND="${DEPEND}"
+
+EXPORT_FUNCTIONS pkg_setup
+
+# ------------------------------------------------------------------------------
+# @eclass-pkg_setup
+#
+# pkg_setup initializes the Java environment
+# ------------------------------------------------------------------------------
+java-pkg-2_pkg_setup() {
+ java-pkg_init
+}
+
+# ------------------------------------------------------------------------------
+# @note
+#
+# We need to initialize the environment in every function because Portage
+# will source /etc/profile between phases and trample all over the env.
+# This is accomplished by phase hooks, which is available with newer versions of
+# portage.
+# ------------------------------------------------------------------------------
+
+pre_pkg-2_setup() {
+ java-pkg-2_pkg_setup
+}
+
+pre_src_unpack() {
+ java-pkg-2_pkg_setup
+}
+
+pre_src_compile() {
+ java-pkg-2_pkg_setup
+}
+
+pre_src_install() {
+ java-pkg-2_pkg_setup
+}
+
+pre_src_test() {
+ java-pkg-2_pkg_setup
+}
+
+pre_pkg_preinst() {
+ java-pkg-2_pkg_setup
+}
+
+pre_pkg_postinst() {
+ java-pkg-2_pkg_setup
+}
+
+# ------------------------------------------------------------------------------
+# @eclass-end
+# ------------------------------------------------------------------------------
diff --git a/eclass/java-pkg-opt-2.eclass b/eclass/java-pkg-opt-2.eclass
new file mode 100644
index 000000000000..3b285b1068f2
--- /dev/null
+++ b/eclass/java-pkg-opt-2.eclass
@@ -0,0 +1,75 @@
+# Eclass for optional Java packages
+#
+# Copyright (c) 2004-2005, Thomas Matthijs <axxo@gentoo.org>
+# Copyright (c) 2004-2005, Gentoo Foundation
+#
+# Licensed under the GNU General Public License, v2
+#
+
+inherit java-utils-2
+
+# ------------------------------------------------------------------------------
+# @eclass-begin
+# @eclass-summary Eclass for packages with optional Java support
+# ------------------------------------------------------------------------------
+
+# ------------------------------------------------------------------------------
+# @ebuild-variable JAVA_PKG_OPT_USE
+#
+# USE flag to control if optional Java stuff is build. Defaults to 'java'.
+# ------------------------------------------------------------------------------
+JAVA_PKG_OPT_USE=${JAVA_PKG_OPT_USE:-java}
+
+# ------------------------------------------------------------------------------
+# ------------------------------------------------------------------------------
+DEPEND="${JAVA_PKG_OPT_USE}? ( ${JAVA_PKG_E_DEPEND} )"
+RDEPEND="${DEPEND}"
+
+# ------------------------------------------------------------------------------
+# ------------------------------------------------------------------------------
+IUSE="${JAVA_PKG_OPT_USE}"
+
+EXPORT_FUNCTIONS pkg_setup
+
+# ------------------------------------------------------------------------------
+# ------------------------------------------------------------------------------
+java-pkg-opt-2_pkg_setup() {
+ use ${JAVA_PKG_OPT_USE} && java-pkg_init
+}
+
+# ------------------------------------------------------------------------------
+# @note
+#
+# We need to initialize the environment in every function because Portage
+# will source /etc/profile between phases and trample all over the env.
+# This is accomplished by phase hooks, which is available with newer versions of
+# portage.
+# ------------------------------------------------------------------------------
+
+pre_pkg_setup() {
+ java-pkg-opt_pkg_setup
+}
+
+pre_src_unpack() {
+ java-pkg-opt_pkg_setup
+}
+
+pre_src_compile() {
+ java-pkg-opt_pkg_setup
+}
+
+pre_src_install() {
+ java-pkg-opt_pkg_setup
+}
+
+pre_src_test() {
+ java-pkg-opt_pkg_setup
+}
+
+pre_pkg_preinst() {
+ java-pkg-opt_pkg_setup
+}
+
+pre_pkg_postinst() {
+ java-pkg-opt_pkg_setup
+}
diff --git a/eclass/java-pkg.eclass b/eclass/java-pkg.eclass
index 79da257354e4..7dfc0b9bf3a5 100644
--- a/eclass/java-pkg.eclass
+++ b/eclass/java-pkg.eclass
@@ -1,13 +1,55 @@
# Copyright 1999-2004 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
-# $Header: /var/cvsroot/gentoo-x86/eclass/java-pkg.eclass,v 1.35 2006/05/22 01:26:51 nichoj Exp $
+# $Header: /var/cvsroot/gentoo-x86/eclass/java-pkg.eclass,v 1.36 2006/06/24 18:36:59 nichoj Exp $
+inherit multilib
-# Skeleton pkg_setup, needed to provide compatibility for migration-overlay.
+JAVA_CONFIG_DEP="|| ( =dev-java/java-config-1.3* =dev-java/java-config-1.2* )"
+DEPEND="${JAVA_CONFIG_DEP}"
+RDEPEND="${JAVA_CONFIG_DEP}"
+
+
+EXPORT_FUNCTIONS pkg_setup
+
+# We need to do a few things to add compatibility between
+# generation-1 and generation-2.
+
+# First we make sure java-config-1 will be used
+export WANT_JAVA_CONFIG="1"
+
+# VMHANDLE is defined in /etc/env.d/20java. This is the handle java-config-2
+# uses for determining which VM to use.
+#
+# We set GENTOO_VM to this, to ensure that /usr/bin/java and company are using
+# the right VM.
+export GENTOO_VM="${VMHANDLE}"
+
+# During pkg_setup, we need to live some crumb trails that we're using
+# in a mixed generation-1/generation-2 environment
+# TODO need to make sure everything that inherits java-pkg and has a pkg_setup
+# uses java-pkg_pkg_setup
java-pkg_pkg_setup() {
- :;
+ java-pkg_announce-qa-violation "using deprecated eclass java-pkg"
+
+ # We need to do a little magic if java-config-2 is around
+ if has_version "=dev-java/java-config-2*"; then
+ ebegin "Enabling generation-2 compatibility"
+ if [[ -n ${GENTOO_VM} ]]; then
+ einfo "Using ${GENTOO_VM}"
+ eend 0
+ else
+ eerror "There was a problem determining which VM to use for Generation-1"
+ eerror "See the list of available VMs by using: java-config-1 -L"
+ eerror "Then select on of those by using: java-config-1 -S <selected vm>"
+ eerror "And once that is done, run: env-update && source /etc/profile"
+ eerror "Then to continue the emerge: emerge --resume"
+ eend 1
+ die "Couldn't determine VM for generation-1"
+ fi
+ fi
}
+
pkglistpath="${T}/java-pkg-list"
java-pkg_doclass()
@@ -22,7 +64,7 @@ java-pkg_do_init_()
if [ -z "${JARDESTTREE}" ] ; then
JARDESTTREE="lib"
- SODESTTREE="lib"
+ SODESTTREE=$(get_libdir)
fi
# Set install paths
@@ -52,17 +94,17 @@ java-pkg_do_init_()
debug-print "jardest=${jardest}"
debug-print "sodest=${sodest}"
debug-print "package_env=${package_env}"
+
}
java-pkg_do_write_()
{
# Create directory for package.env
- if [ ! -d "${D}${shareroot}" ] ; then
- install -d "${D}${shareroot}"
- fi
+ dodir "${shareroot}"
# Create package.env
echo "DESCRIPTION=${DESCRIPTION}" > "${package_env}"
+ echo "GENERATION=1" >> "${package_env}"
if [ -n "${cp_pkg}" ]; then
echo "CLASSPATH=${cp_prepend}:${cp_pkg}:${cp_append}" >> "${package_env}"
fi
@@ -175,9 +217,7 @@ java-pkg_dojar()
fi
# Make sure directory is created
- if [ ! -d "${D}${jardest}" ] ; then
- install -d "${D}${jardest}"
- fi
+ dodir ${jardest}
for i in $* ; do
mysrc=$(java-pkg_do_getsrc_)
@@ -374,4 +414,9 @@ java-pkg_dosrc() {
|| die "failed to install sources"
}
-EXPORT_FUNCTIONS pkg_setup
+
+java-pkg_announce-qa-violation() {
+ if hasq java-strict ${FEATURES}; then
+ echo "Java QA Notice: $@" >&2
+ fi
+}
diff --git a/eclass/java-utils-2.eclass b/eclass/java-utils-2.eclass
new file mode 100644
index 000000000000..6f04b9eb9e45
--- /dev/null
+++ b/eclass/java-utils-2.eclass
@@ -0,0 +1,1747 @@
+# Base eclass for Java packages
+#
+# Copyright (c) 2004-2005, Thomas Matthijs <axxo@gentoo.org>
+# Copyright (c) 2004, Karl Trygve Kalleberg <karltk@gentoo.org>
+# Copyright (c) 2004-2005, Gentoo Foundation
+#
+# Licensed under the GNU General Public License, v2
+#
+
+
+# -----------------------------------------------------------------------------
+# @eclass-begin
+# @eclass-shortdesc Java Utility eclass
+# @eclass-maintainer java@gentoo.org
+#
+# This eclass provides functionality which is used by
+# java-pkg.eclass and java-pkg-opt.eclass as well as from ebuilds.
+#
+# @warning
+# You probably don't want to inherit this directly from an ebuild. Instead,
+# you should inherit java-ant for Ant-based Java packages, java-pkg for other
+# Java packages, or java-pkg-opt for packages that have optional Java support.
+#
+# -----------------------------------------------------------------------------
+
+inherit eutils versionator multilib
+
+# -----------------------------------------------------------------------------
+# @section-begin variables
+# @section-title Variables
+#
+# Summary of variables which control the behavior of building Java packges.
+# -----------------------------------------------------------------------------
+
+# Make sure we use java-config-2
+export WANT_JAVA_CONFIG="2"
+
+# -----------------------------------------------------------------------------
+# @variable-internal JAVA_PKG_E_DEPEND
+#
+# This is a convience variable to be used from the other java eclasses. This is
+# the version of java-config we want to use. We also need a recent version
+# portage, that includes phase hooks.
+# -----------------------------------------------------------------------------
+JAVA_PKG_E_DEPEND=">=dev-java/java-config-2.0.19-r1 >=sys-apps/portage-2.1_pre1"
+
+# -----------------------------------------------------------------------------
+# @variable-external JAVA_PKG_ALLOW_VM_CHANGE
+# @variable-default yes
+#
+# Allow this eclass to change the active VM?
+# If your system VM isn't sufficient for the package, the build will fail.
+# @note This is useful for testing specific VMs.
+# -----------------------------------------------------------------------------
+JAVA_PKG_ALLOW_VM_CHANGE=${JAVA_PKG_ALLOW_VM_CHANGE:="yes"}
+
+# -----------------------------------------------------------------------------
+# @variable-external JAVA_PKG_FORCE_VM
+#
+# Explicitly set a particular VM to use. If its not valid, it'll fall back to
+# whatever /etc/java-config-2/build/jdk.conf would elect to use.
+#
+# Should only be used for testing and debugging.
+#
+# @example Use sun-jdk-1.5 to emerge foo
+# JAVA_PKG_FORCE_VM=sun-jdk-1.5 emerge foo
+#
+# -----------------------------------------------------------------------------
+
+# -----------------------------------------------------------------------------
+# @variable-external JAVA_PKG_WANT_SOURCE
+#
+# Specify a specific VM version to compile for to use for -source.
+# Normally this is determined from DEPEND.
+# See java-pkg_get-source function below.
+#
+# Should only be used for testing and debugging.
+#
+# @seealso java-pkg_get-source
+#
+# @example Use 1.4 source to emerge baz
+# JAVA_PKG_WANT_SOURCE=1.4 emerge baz
+# -----------------------------------------------------------------------------
+
+# -----------------------------------------------------------------------------
+# @variable-external JAVA_PKG_WANT_TARGET
+#
+# Same as JAVA_PKG_WANT_SOURCE above but for -target.
+# See java-pkg_get-target function below.
+#
+# Should only be used for testing and debugging.
+#
+# @seealso java-pkg_get-target
+#
+# @example emerge bar to be compatible with 1.3
+# JAVA_PKG_WANT_TARGET=1.3 emerge bar
+# -----------------------------------------------------------------------------
+
+# -----------------------------------------------------------------------------
+# @variable-internal JAVA_PKG_COMPILER_DIR
+# @default /usr/share/java-config-2/compiler
+#
+# Directory where compiler settings are saved, without trailing slash.
+# Probably shouldn't touch this variable.
+# -----------------------------------------------------------------------------
+JAVA_PKG_COMPILER_DIR=${JAVA_PKG_COMPILER_DIR:="/usr/share/java-config-2/compiler"}
+
+
+# -----------------------------------------------------------------------------
+# @variable-internal JAVA_PKG_COMPILERS_CONF
+# @variable-default /etc/java-config-2/build/compilers.conf
+#
+# Path to file containing information about which compiler to use.
+# Can be overloaded, but it should be overloaded for testing.
+# -----------------------------------------------------------------------------
+JAVA_PKG_COMPILERS_CONF=${JAVA_PKG_COMPILERS_CONF:="/etc/java-config-2/build/compilers.conf"}
+
+# -----------------------------------------------------------------------------
+# @variable-external JAVA_PKG_FORCE_COMPILER
+#
+# Explicitly set a list of compilers to use. This is normally read from
+# JAVA_PKG_COMPILERS_CONF.
+#
+# @note This should only be used internally or for testing.
+# @example Use jikes and javac, in that order
+# JAVA_PKG_FORCE_COMPILER="jikes javac"
+# -----------------------------------------------------------------------------
+
+# TODO document me
+JAVA_PKG_QA_VIOLATIONS=0
+
+# -----------------------------------------------------------------------------
+# @section-end variables
+# -----------------------------------------------------------------------------
+
+
+# -----------------------------------------------------------------------------
+# @section-begin install
+# @section-summary Install functions
+#
+# These are used to install Java-related things, such as jars, Javadocs, JNI
+# libraries, etc.
+# -----------------------------------------------------------------------------
+
+
+# -----------------------------------------------------------------------------
+# @ebuild-function java-pkg_dojar
+#
+# Installs any number of jars.
+# Jar's will be installed into /usr/share/${PN}(-${SLOT})/lib/ by default.
+# You can use java-pkg_jarinto to change this path.
+# You should never install a jar with a package version in the filename.
+# Instead, use java-pkg_newjar defined below.
+#
+# @example
+# java-pkg_dojar dist/${PN}.jar dist/${PN}-core.jar
+#
+# @param $* - list of jars to install
+# ------------------------------------------------------------------------------
+java-pkg_dojar() {
+ debug-print-function ${FUNCNAME} $*
+
+ [[ ${#} -lt 1 ]] && die "At least one argument needed"
+
+ java-pkg_check-phase install
+ java-pkg_init_paths_
+
+ # Create JARDEST if it doesn't exist
+ dodir ${JAVA_PKG_JARDEST}
+
+ local jar
+ # for each jar
+ for jar in "$@"; do
+ local jar_basename=$(basename "${jar}")
+
+ java-pkg_check-versioned-jar ${jar_basename}
+
+ # check if it exists
+ if [[ -e "${jar}" ]] ; then
+ # install it into JARDEST if it's a non-symlink
+ if [[ ! -L "${jar}" ]] ; then
+ INSDESTTREE="${JAVA_PKG_JARDEST}" \
+ doins "${jar}" || die "failed to install ${jar}"
+ java-pkg_append_ JAVA_PKG_CLASSPATH "${JAVA_PKG_JARDEST}/${jar_basename}"
+ debug-print "installed ${jar} to ${D}${JAVA_PKG_JARDEST}"
+ # make a symlink to the original jar if it's symlink
+ else
+ # TODO use dosym, once we find something that could use it
+ # -nichoj
+ ln -s "$(readlink "${jar}")" "${D}${JAVA_PKG_JARDEST}/${jar_basename}"
+ debug-print "${jar} is a symlink, linking accordingly"
+ fi
+ else
+ die "${jar} does not exist"
+ fi
+ done
+
+ java-pkg_do_write_
+}
+
+
+
+# ------------------------------------------------------------------------------
+# @ebuild-function java-pkg_regjar
+#
+# Records an already installed jar in the package.env
+# This would mostly be used if the package has make or a custom script to
+# install things.
+#
+# Example:
+# java-pkg-regjar ${D}/opt/foo/lib/foo.jar
+#
+# @param $@ - jars to record
+# ------------------------------------------------------------------------------
+# TODO fix me!
+java-pkg_regjar() {
+ debug-print-function ${FUNCNAME} $*
+
+ java-pkg_check-phase install
+
+ [[ ${#} -lt 1 ]] && die "at least one argument needed"
+
+ java-pkg_init_paths_
+
+ local jar jar_dir jar_file
+ for jar in "$@"; do
+ # TODO use java-pkg_check-versioned-jar
+ if [[ -e "${jar}" ]]; then
+ java-pkg_append_ JAVA_PKG_CLASSPATH "${jar}"
+ elif [[ -e "${D}${jar}" ]]; then
+ java-pkg_append_ JAVA_PKG_CLASSPATH "${jar#${D}}"
+ else
+ die "${jar} does not exist"
+ fi
+ done
+
+ java-pkg_do_write_
+}
+
+
+# ------------------------------------------------------------------------------
+# @ebuild-function java-pkg_newjar
+#
+# Installs a jar with a new name
+#
+# @example: install a versioned jar without the version
+# java-pkg_newjar dist/${P}.jar ${PN}.jar
+#
+# @param $1 - jar to install
+# @param $2 - new name for jar - defaults to ${PN}.jar if not specified
+# ------------------------------------------------------------------------------
+java-pkg_newjar() {
+ debug-print-function ${FUNCNAME} $*
+
+ local original_jar="${1}"
+ local new_jar="${2:-${PN}.jar}"
+ local new_jar_dest="${T}/${new_jar}"
+
+ [[ -z ${original_jar} ]] && die "Must specify a jar to install"
+ [[ ! -f ${original_jar} ]] && die "${new_jar} does not exist!"
+
+ rm -f "${new_jar_dest}" || die "Failed to remove ${new_jar_dest}"
+ cp "${original_jar}" "${new_jar_dest}" \
+ || die "Failed to copy ${original_jar} to ${new_jar_dest}"
+ java-pkg_dojar "${new_jar_dest}"
+}
+
+
+# ------------------------------------------------------------------------------
+# @ebuild-function java-pkg_addcp
+#
+# Add something to the package's classpath. For jars, you should use dojar,
+# newjar, or regjar. This is typically used to add directories to the classpath.
+#
+# TODO add example
+# @param $@ - value to append to JAVA_PKG_CLASSPATH
+# ------------------------------------------------------------------------------
+java-pkg_addcp() {
+ java-pkg_append_ JAVA_PKG_CLASSPATH "${@}"
+ java-pkg_do_write_
+}
+
+
+# ------------------------------------------------------------------------------
+# @ebuild-function java-pkg_doso
+#
+# Installs any number of JNI libraries
+# They will be installed into /usr/lib by default, but java-pkg_sointo
+# can be used change this path
+#
+# Example:
+# java-pkg_doso *.so
+#
+# @param $@ - JNI libraries to install
+# ------------------------------------------------------------------------------
+java-pkg_doso() {
+ debug-print-function ${FUNCNAME} $*
+
+ [[ ${#} -lt 1 ]] && "At least one argument required for ${FUNCNAME}"
+ java-pkg_check-phase install
+
+ [[ ${#} -lt 1 ]] && die "At least one argument required for ${FUNCNAME}"
+
+ java-pkg_init_paths_
+
+ local lib
+ # for each lib
+ for lib in "$@" ; do
+ # if the lib exists...
+ if [[ -e "${lib}" ]] ; then
+ # install if it isn't a symlink
+ if [[ ! -L "${lib}" ]] ; then
+ INSDESTTREE="${JAVA_PKG_LIBDEST}" \
+ INSOPTIONS="${LIBOPTIONS}" \
+ doins "${lib}" || "failed to install ${lib}"
+ java-pkg_append_ JAVA_PKG_LIBRARY "${JAVA_PKG_LIBDEST}"
+ debug-print "Installing ${lib} to ${JAVA_PKG_LIBDEST}"
+ # otherwise make a symlink to the symlink's origin
+ else
+ # TODO use dosym
+ ln -s "$(readlink "${lib}")" "${D}${JAVA_PKG_LIBDEST}/$(basename "${lib}")"
+ debug-print "${lib} is a symlink, linking accordanly"
+ fi
+ # otherwise die
+ else
+ die "${lib} does not exist"
+ fi
+ done
+
+ java-pkg_do_write_
+}
+
+# ------------------------------------------------------------------------------
+# @ebuild-function java-pkg_regso
+#
+# Registers an already JNI library in package.env.
+#
+# Example:
+# java-pkg_regso *.so /path/*.so
+#
+# @param $@ - JNI libraries to register
+# ------------------------------------------------------------------------------
+java-pkg_regso() {
+ debug-print-function ${FUNCNAME} $*
+
+ java-pkg_check-phase install
+
+ [[ ${#} -lt 1 ]] && "at least one argument needed"
+
+ java-pkg_init_paths_
+
+ local lib target_dir
+ for lib in "$@" ; do
+ # Check the absolute path of the lib
+ if [[ -e "${lib}" ]] ; then
+ target_dir="$(java-pkg_expand_dir_ ${lib})"
+ java-pkg_append_ JAVA_PKG_LIBRARY "/${target_dir#${D}}"
+ # Check the path of the lib relative to ${D}
+ elif [[ -e "${D}${lib}" ]]; then
+ target_dir="$(java-pkg_expand_dir_ ${D}${lib})"
+ java-pkg_append_ JAVA_PKG_LIBRARY "${target_dir}"
+ else
+ die "${lib} does not exist"
+ fi
+ done
+
+ java-pkg_do_write_
+}
+
+# ------------------------------------------------------------------------------
+# @ebuild-function java-pkg_jarinto
+#
+# Changes the path jars are installed into
+#
+# @param $1 - new location to install jars into.
+# -----------------------------------------------------------------------------
+java-pkg_jarinto() {
+ debug-print-function ${FUNCNAME} $*
+
+ JAVA_PKG_JARDEST="${1}"
+}
+
+# ------------------------------------------------------------------------------
+# @ebuild-function java-pkg_sointo
+#
+# Changes the path that JNI libraries are installed into.
+#
+# @param $1 - new location to install JNI libraries into.
+# ------------------------------------------------------------------------------
+java-pkg_sointo() {
+ debug-print-function ${FUNCNAME} $*
+
+ JAVA_PKG_LIBDEST="${1}"
+}
+
+# ------------------------------------------------------------------------------
+# @ebuild-function java-pkg_dohtml
+#
+# Install Javadoc HTML documentation
+#
+# @example
+# java-pkg_dohtml dist/docs/
+#
+# ------------------------------------------------------------------------------
+java-pkg_dohtml() {
+ debug-print-function ${FUNCNAME} $*
+
+ [[ ${#} -lt 1 ]] && die "At least one argument required for ${FUNCNAME}"
+ # TODO-nichoj find out what exactly -f package-list does
+ dohtml -f package-list "$@"
+ # this probably shouldn't be here but it provides
+ # a reasonable way to catch # docs for all of the
+ # old ebuilds.
+ java-pkg_recordjavadoc
+}
+
+# TODO document
+java-pkg_dojavadoc() {
+ local dir="$1"
+
+ java-pkg_check-phase install
+
+ [[ -z "${dir}" ]] && die "Must specify a directory!"
+ [[ ! -d "${dir}" ]] && die "${dir} does not exist, or isn't a directory!"
+
+ local dir_to_install="${dir}"
+ if [[ "$(basename "${dir}")" != "api" ]]; then
+ dir_to_install="${T}/api"
+ # TODO use doins
+ cp -r "${dir}" "${dir_to_install}" || die "cp failed"
+ fi
+
+ java-pkg_dohtml -r ${dir_to_install}
+}
+
+# ------------------------------------------------------------------------------
+# @ebuild-function java-pkg_dosrc
+#
+# Installs a zip containing the source for a package, so it can used in
+# from IDEs like eclipse and netbeans.
+#
+# Ebuild needs to DEPEND on app-arch/zip to use this.
+#
+# It also should be controlled by USE=source.
+#
+# @example:
+# java-pkg_dosrc src/*
+#
+# ------------------------------------------------------------------------------
+# TODO change so it the arguments it takes are the base directories containing
+# source -nichoj
+# TODO should we be able to handle multiple calls to dosrc? -nichoj
+# TODO maybe we can take an existing zip/jar? -nichoj
+# FIXME apparently this fails if you give it an empty directories
+java-pkg_dosrc() {
+ debug-print-function ${FUNCNAME} $*
+
+ [ ${#} -lt 1 ] && die "At least one argument needed"
+ if ! hasq source ${IUSE}; then
+ echo "Java QA Notice: ${FUNCNAME} called without source in IUSE"
+ fi
+
+ java-pkg_check-phase install
+
+ [[ ${#} -lt 1 ]] && die "At least one argument needed"
+
+ java-pkg_init_paths_
+
+ local zip_name="${PN}-src.zip"
+ local zip_path="${T}/${zip_name}"
+ local dir
+ for dir in ${@}; do
+ local dir_parent=$(dirname "${dir}")
+ local dir_name=$(basename "${dir}")
+ pushd ${dir_parent} > /dev/null || die "problem entering ${dir_parent}"
+ zip -q -r ${zip_path} ${dir_name} -i '*.java'
+ local result=$?
+ # 12 means zip has nothing to do
+ if [[ ${result} != 12 && ${result} != 0 ]]; then
+ die "failed to zip ${dir_name}"
+ fi
+ popd >/dev/null
+ done
+
+ # Install the zip
+ INSDESTTREE=${JAVA_PKG_SOURCESPATH} \
+ doins ${zip_path} || die "Failed to install source"
+
+ JAVA_SOURCES="${JAVA_PKG_SOURCESPATH}/${zip_name}"
+ java-pkg_do_write_
+}
+
+# ------------------------------------------------------------------------------
+# @ebuild-function java-pkg_dolauncher
+#
+# Make a wrapper script to lauch/start this package
+# If necessary, the wrapper will switch to the appropriate VM.
+#
+# @param $1 - filename of launcher to create
+# @param $2 - options, as follows:
+# --main the.main.class.too.start
+# --jar /the/jar/too/launch.jar
+# --java_args 'Extra arguments to pass too jave'
+# --pkg_args 'extra arguments too pass too the package'
+# --pwd
+# -into
+# -pre
+# ------------------------------------------------------------------------------
+java-pkg_dolauncher() {
+ debug-print-function ${FUNCNAME} $*
+
+ java-pkg_check-phase install
+
+ [[ ${#} -lt 1 ]] && die "Need at least one argument"
+
+ java-pkg_init_paths_
+
+ local name="${1}"
+ # TODO rename to launcher
+ local target="${T}/${name}"
+ local target_dir pre
+ shift
+
+ echo "#!/bin/bash" > "${target}"
+ while [[ -n "${1}" && -n "${2}" ]]; do
+ local var=${1} value=${2}
+ if [[ "${var:0:2}" == "--" ]]; then
+ echo "gjl_${var:2}=\"${value}\"" >> "${target}"
+ elif [[ "${var}" == "-into" ]]; then
+ target_dir="${value}"
+ elif [[ "${var}" == "-pre" ]]; then
+ pre="${value}"
+ fi
+ shift 2
+ done
+ echo "gjl_package=${JAVA_PKG_NAME}" >> "${target}"
+ [[ -n "${pre}" ]] && [[ -f "${pre}" ]] && cat "${pre}" >> "${target}"
+ echo "source /usr/share/java-config-2/launcher/launcher.bash" >> "${target}"
+
+ if [[ -n "${into}" ]]; then
+ DESTTREE="${target_dir}" dobin "${target}"
+ local ret=$?
+ return ${ret}
+ else
+ dobin "${target}"
+ fi
+}
+
+# ------------------------------------------------------------------------------
+# Install war files.
+# TODO document
+# ------------------------------------------------------------------------------
+java-pkg_dowar() {
+ debug-print-function ${FUNCNAME} $*
+
+ # Check for arguments
+ [[ ${#} -lt 1 ]] && die "At least one argument needed"
+ java-pkg_check-phase install
+
+ java-pkg_init_paths_
+
+ local war
+ for war in $* ; do
+ local warpath
+ # TODO evaluate if we want to handle symlinks differently -nichoj
+ # Check for symlink
+ if [[ -L "${war}" ]] ; then
+ cp "${war}" "${T}"
+ warpath="${T}$(basename "${war}")"
+ # Check for directory
+ # TODO evaluate if we want to handle directories differently -nichoj
+ elif [[ -d "${war}" ]] ; then
+ echo "dowar: warning, skipping directory ${war}"
+ continue
+ else
+ warpath="${war}"
+ fi
+
+ # Install those files like you mean it
+ INSOPTIONS="-m 0644" \
+ INSDESTTREE=${JAVA_PKG_WARDEST} \
+ doins ${warpath}
+ done
+}
+
+# ------------------------------------------------------------------------------
+# @internal-function java-pkg_recordjavadoc
+# Scan for JavaDocs, and record their existence in the package.env file
+#
+# TODO make sure this in the proper section
+# ------------------------------------------------------------------------------
+java-pkg_recordjavadoc()
+{
+ debug-print-function ${FUNCNAME} $*
+ # the find statement is important
+ # as some packages include multiple trees of javadoc
+ JAVADOC_PATH="$(find ${D}/usr/share/doc/ -name allclasses-frame.html -printf '%h:')"
+ # remove $D - TODO: check this is ok with all cases of the above
+ JAVADOC_PATH="${JAVADOC_PATH//${D}}"
+ if [[ -n "${JAVADOC_PATH}" ]] ; then
+ debug-print "javadocs found in ${JAVADOC_PATH%:}"
+ java-pkg_do_write_
+ else
+ debug-print "No javadocs found"
+ fi
+}
+
+# ------------------------------------------------------------------------------
+# @section-end install
+# ------------------------------------------------------------------------------
+
+# ------------------------------------------------------------------------------
+# @begin-section query
+# Use these to build the classpath for building a package.
+# ------------------------------------------------------------------------------
+
+# ------------------------------------------------------------------------------
+# @ebuild-function java-pkg_jar-from
+#
+# Makes a symlink to a jar from a certain package
+# A lot of java packages include dependencies in a lib/ directory
+# You can use this function to replace these bundled dependencies.
+#
+# Example: get all jars from xerces slot 2
+# java-pkg_jar-from xerces-2
+# Example: get a specific jar from xerces slot 2
+# java-pkg_jar-from xerces-2 xml-apis.jar
+# Example get a specific jar from xerces slot 2, and name it diffrently
+# java-pkg_jar-from xerces-2 xml-apis.jar xml.jar
+#
+# @param $1 - Package to get jars from.
+# @param $2 - jar from package. If not specified, all jars will be used.
+# @param $3 - When a single jar is specified, destination filename of the
+# symlink. Defaults to the name of the jar.
+# ------------------------------------------------------------------------------
+# TODO could probably be cleaned up a little
+java-pkg_jar-from() {
+ debug-print-function ${FUNCNAME} $*
+
+ local target_pkg="${1}" target_jar="${2}" destjar="${3}"
+
+ [[ -z ${target_pkg} ]] && die "Must specify a package"
+
+ # default destjar to the target jar
+ [[ -z "${destjar}" ]] && destjar="${target_jar}"
+
+ local classpath="$(java-config --classpath=${target_pkg})"
+ [[ $? != 0 ]] && die "There was a problem getting the classpath for ${target_pkg}"
+
+ local jar
+ for jar in ${classpath//:/ }; do
+ local jar_name=$(basename "${jar}")
+ if [[ ! -f "${jar}" ]] ; then
+ debug-print "${jar} from ${target_pkg} does not exist"
+ die "Installation problems with jars in ${target_pkg} - is it installed?"
+ fi
+ # If no specific target jar was indicated, link it
+ if [[ -z "${target_jar}" ]] ; then
+ [[ -f "${target_jar}" ]] && rm "${target_jar}"
+ ln -snf "${jar}" \
+ || die "Failed to make symlink from ${jar} to ${jar_name}"
+ java-pkg_record-jar_ "${target_pkg}" "${jar}"
+ # otherwise, if the current jar is the target jar, link it
+ elif [[ "${jar_name}" == "${target_jar}" ]] ; then
+ [[ -f "${destjar}" ]] && rm "${destjar}"
+ ln -snf "${jar}" "${destjar}" \
+ || die "Failed to make symlink from ${jar} to ${destjar}"
+ java-pkg_record-jar_ "${target_pkg}" "${jar}"
+ return 0
+ fi
+ done
+ # if no target was specified, we're ok
+ if [[ -z "${target_jar}" ]] ; then
+ return 0
+ # otherwise, die bitterly
+ else
+ die "Failed to find ${target_jar:-jar} in ${target_pkg}"
+ fi
+}
+
+# ------------------------------------------------------------------------------
+# @ebuild-function java-pkg_jarfrom
+#
+# See java-pkg_jar-from
+# ------------------------------------------------------------------------------
+java-pkg_jarfrom() {
+ java-pkg_jar-from "$@"
+}
+
+# ------------------------------------------------------------------------------
+# @ebuild-function java-pkg_getjars
+#
+# Get the classpath provided by any number of packages
+# Among other things, this can be passed to 'javac -classpath' or 'ant -lib'.
+#
+# Example: Get the classpath for xerces-2,
+# java-pkg_getjars xerces-2 xalan
+# Example Return:
+# /usr/share/xerces-2/lib/xml-apis.jar:/usr/share/xerces-2/lib/xmlParserAPIs.jar:/usr/share/xalan/lib/xalan.jar
+#
+# @param $@ - list of packages to get jars from
+# ------------------------------------------------------------------------------
+java-pkg_getjars() {
+ debug-print-function ${FUNCNAME} $*
+
+ [[ ${#} -lt 1 ]] && die "At least one argument needed"
+
+ # NOTE could probably just pass $@ to java-config --classpath. and return it
+ local classpath pkg
+ for pkg in ${@//,/ }; do
+ #for pkg in $(echo "$@" | tr ',' ' '); do
+ jars="$(java-config --classpath=${pkg})"
+ debug-print "${pkg}:${jars}"
+ # TODO should we ensure jars exist?
+ if [[ -z "${classpath}" ]]; then
+ classpath="${jars}"
+ else
+ classpath="${classpath}:${jars}"
+ fi
+ java-pkg_record-jar_ "${pkg}"
+ done
+ echo "${classpath}"
+}
+
+# ------------------------------------------------------------------------------
+# @ebuild-function java-pkg_getjar
+#
+# Get the filename of a single jar from a package
+#
+# @example
+# java-pkg_getjar xerces-2 xml-apis.jar
+# @example-return
+# /usr/share/xerces-2/lib/xml-apis.jar
+#
+# @param $1 - package to use
+# @param $2 - jar to get
+# ------------------------------------------------------------------------------
+java-pkg_getjar() {
+ debug-print-function ${FUNCNAME} $*
+
+ local pkg="${1}" target_jar="${2}" jar
+ [[ -z ${pkg} ]] && die "Must specify package to get a jar from"
+ [[ -z ${target_jar} ]] && die "Must specify jar to get"
+
+ # TODO check that package is actually installed
+ local classpath=$(java-config --classpath=${pkg})
+ [[ $? != 0 ]] && die "There could not find classpath for ${pkg}. Are you sure its installed?"
+ for jar in ${classpath//:/ }; do
+ if [[ ! -f "${jar}" ]] ; then
+ die "Installation problems with jars in ${pkg} - is it installed?"
+ fi
+
+ if [[ "$(basename ${jar})" == "${target_jar}" ]] ; then
+ java-pkg_record-jar_ "${pkg}" "${jar}"
+ echo "${jar}"
+ return 0
+ fi
+ done
+
+ die "Could not find ${target_jar} in ${pkg}"
+ return 1
+}
+
+# This function reads stdin, and based on that input, figures out how to
+# populate jars from the filesystem.
+# Need to figure out a good way of making use of this, ie be able to use a
+# string that was built instead of stdin
+# NOTE: this isn't quite ready for primetime.
+#java-pkg_populate-jars() {
+# local line
+#
+# read line
+# while [[ -n "${line}" ]]; do
+# # Ignore comments
+# [[ ${line%%#*} == "" ]] && continue
+#
+# # get rid of any spaces
+# line="${line// /}"
+#
+# # format: path=jarinfo
+# local path=${line%%=*}
+# local jarinfo=${line##*=}
+#
+# # format: jar@package
+# local jar=${jarinfo%%@*}.jar
+# local package=${jarinfo##*@}
+# if [[ -n ${replace_only} ]]; then
+# [[ ! -f $path ]] && die "No jar exists at ${path}"
+# fi
+# if [[ -n ${create_parent} ]]; then
+# local parent=$(dirname ${path})
+# mkdir -p "${parent}"
+# fi
+# java-pkg_jar-from "${package}" "${jar}" "${path}"
+#
+# read line
+# done
+#}
+
+# ------------------------------------------------------------------------------
+# @section-end query
+# ------------------------------------------------------------------------------
+
+# ------------------------------------------------------------------------------
+# @section-begin helper
+# @section-summary Helper functions
+#
+# Various other functions to use from an ebuild
+# ------------------------------------------------------------------------------
+
+# ------------------------------------------------------------------------------
+# @ebuild-function java-pkg_need
+#
+# Adds virtual dependencies, which can optionally be controlled by a USE flag.
+# Currently supported virtuals are:
+# javamail
+# jdbc-stdext
+# jaf
+# jdbc-rowset
+# jms
+#
+# @param $1 - Optionally indicate that the dependencies are controlled by
+# a use flag by specifying '--use' Requires $2.
+# @param $2 - USE flag which will enable the dependencies.
+# @param $@ - virtual packages to add depenedencies for
+# ------------------------------------------------------------------------------
+# TODO rewrite to parse a line based declaration file instead -- karltk
+#java-pkg_need() {
+# debug-print-function ${FUNCNAME} $*
+# local useflag
+# if [[ ${1} == "--use" ]]; then
+# useflag="${2}"
+# shift 2
+# fi
+#
+# if [[ -z ${1} ]]; then
+# die "Must specify at least one virtual package."
+# fi
+#
+# local depstr newdepstr
+#
+# for virtual in ${@}; do
+# if has ${virtual} ${JAVA_PKG_VNEED}; then
+# debug-print "Already registered virtual ${virtual}"
+# continue
+# fi
+# case ${virtual} in
+# javamail)
+# debug-print "java-pkg_need: adding javamail dependencies"
+# newdepstr="|| ( dev-java/gnu-javamail dev-java/sun-javamail-bin )"
+# ;;
+# jdbc-stdext)
+# debug-print "java-pkg_need: adding jdbc-stdext dependencies"
+# newdepstr="|| ( >=virtual/jdk-1.4 dev-java/jdbc2-stdext )"
+# ;;
+# jaf)
+# debug-print "java-pkg_need: adding jaf dependencies"
+# newdepstr="|| ( dev-java/gnu-jaf dev-java/sun-jaf-bin )"
+# ;;
+# jdbc-rowset)
+# debug-print "java-pkg_need: adding jdbc-rowset dependencies"
+# newdepstr="|| ( >=virtual/jdk-1.5 dev-java/sun-jdbc-rowset )"
+# ;;
+# jms)
+# debug-print "java-pkg_need: adding jms dependencies"
+# newdepstr="|| ( dev-java/sun-jms dev-java/openjms )"
+# ;;
+# *)
+# die "Invalid virtual: ${virtual}"
+# esac
+#
+# export JAVA_PKG_VNEED="${JAVA_PKG_VNEED} ${virtual}"
+#
+# if [[ -n ${useflag} ]]; then
+# depstr="${depstr} ${useflag}? ( ${newdepstr} )"
+# else
+# depstr="${depstr} ${newdepstr}"
+# fi
+# done
+#
+# [[ -z ${JAVA_PKG_NV_DEPEND} ]] && export JAVA_PKG_NV_DEPEND="${DEPEND}"
+# [[ -z ${JAVA_PKG_NV_RDEPEND} ]] && export JAVA_PKG_NV_RDEPEND="${RDEPEND}"
+#
+# export DEPEND="${DEPEND} ${depstr}"
+# export RDEPEND="${RDEPEND} ${depstr}"
+#}
+
+# This should be used after S has been populated with symlinks to jars
+# TODO document
+java-pkg_ensure-no-bundled-jars() {
+ debug-print-function ${FUNCNAME} $*
+ pushd ${WORKDIR} >/dev/null 2>/dev/null
+
+ local bundled_jars=$(find . -name "*.jar" -type f)
+ if [[ -n ${bundled_jars} ]]; then
+ echo "Bundled jars found:"
+ local jar
+ for jar in ${bundled_jars}; do
+ echo $(pwd)${jar/./}
+ done
+ die "Bundled jars found!"
+
+ fi
+ popd >/dev/null 2>/dev/null
+}
+
+# ------------------------------------------------------------------------------
+# @internal-function java-pkg_ensure-vm-version-sufficient
+#
+# Checks if we have a sufficient VM and dies if we don't.
+#
+# ------------------------------------------------------------------------------
+java-pkg_ensure-vm-version-sufficient() {
+ debug-print-function ${FUNCNAME} $*
+
+ if ! java-pkg_is-vm-version-sufficient; then
+ debug-print "VM is not suffient"
+ eerror "Current Java VM cannot build this package"
+ einfo "Please use java-config -S to set the correct one"
+ die "Active Java VM cannot build this package"
+ fi
+}
+
+# ------------------------------------------------------------------------------
+# @internal-function java-pkg_is-vm-version-sufficient
+#
+# @return zero - VM is sufficient
+# @return non-zero - VM is not sufficient
+# ------------------------------------------------------------------------------
+java-pkg_is-vm-version-sufficient() {
+ debug-print-function ${FUNCNAME} $*
+
+ depend-java-query --is-sufficient "${DEPEND}" > /dev/null
+ return $?
+}
+
+# ------------------------------------------------------------------------------
+# @internal-function java-pkg_ensure-vm-version-eq
+#
+# Die if the current VM is not equal to the argument passed.
+#
+# @param $@ - Desired VM version to ensure
+# ------------------------------------------------------------------------------
+java-pkg_ensure-vm-version-eq() {
+ debug-print-function ${FUNCNAME} $*
+
+ if ! java-pkg_is-vm-version-eq $@ ; then
+ debug-print "VM is not suffient"
+ eerror "This package requires a Java VM version = $@"
+ einfo "Please use java-config -S to set the correct one"
+ die "Active Java VM too old"
+ fi
+}
+
+# ------------------------------------------------------------------------------
+# @internal-function java-pkg_is-vm-version-eq
+#
+# @param $@ - VM version to compare current VM to
+# @return zero - VM versions are equal
+# @return non-zero - VM version are not equal
+# ------------------------------------------------------------------------------
+java-pkg_is-vm-version-eq() {
+ debug-print-function ${FUNCNAME} $*
+
+ local needed_version="$@"
+
+ [[ -z "${needed_version}" ]] && die "need an argument"
+
+ local vm_version="$(java-pkg_get-vm-version)"
+
+ vm_version="$(get_version_component_range 1-2 "${vm_version}")"
+ needed_version="$(get_version_component_range 1-2 "${needed_version}")"
+
+ if [[ -z "${vm_version}" ]]; then
+ debug-print "Could not get JDK version from DEPEND"
+ return 1
+ else
+ if [[ "${vm_version}" == "${needed_version}" ]]; then
+ debug-print "Detected a JDK(${vm_version}) = ${needed_version}"
+ return 0
+ else
+ debug-print "Detected a JDK(${vm_version}) != ${needed_version}"
+ return 1
+ fi
+ fi
+}
+
+# ------------------------------------------------------------------------------
+# @internal-function java-pkg_ensure-vm-version-ge
+#
+# Die if the current VM is not greater than the desired version
+#
+# @param $@ - VM version to compare current to
+# ------------------------------------------------------------------------------
+java-pkg_ensure-vm-version-ge() {
+ debug-print-function ${FUNCNAME} $*
+
+ if ! java-pkg_is-vm-version-ge "$@" ; then
+ debug-print "vm is not suffient"
+ eerror "This package requires a Java VM version >= $@"
+ einfo "Please use java-config -S to set the correct one"
+ die "Active Java VM too old"
+ fi
+}
+
+# ------------------------------------------------------------------------------
+# @internal-function java-pkg_is-vm-version-ge
+#
+# @param $@ - VM version to compare current VM to
+# @return zero - current VM version is greater than checked version
+# @return non-zero - current VM version is not greater than checked version
+# ------------------------------------------------------------------------------
+java-pkg_is-vm-version-ge() {
+ debug-print-function ${FUNCNAME} $*
+
+ local needed_version=$@
+ local vm_version=$(java-pkg_get-vm-version)
+ if [[ -z "${vm_version}" ]]; then
+ debug-print "Could not get JDK version from DEPEND"
+ return 1
+ else
+ if version_is_at_least "${needed_version}" "${vm_version}"; then
+ debug-print "Detected a JDK(${vm_version}) >= ${needed_version}"
+ return 0
+ else
+ debug-print "Detected a JDK(${vm_version}) < ${needed_version}"
+ return 1
+ fi
+ fi
+}
+
+# ------------------------------------------------------------------------------
+# @ebuild-function java-pkg_get-source
+#
+# Determines what source version should be used, for passing to -source.
+# Unless you want to break things you probably shouldn't set _WANT_SOURCE
+#
+# @return string - Either the lowest possible source, or JAVA_PKG_WANT_SOURCE
+# ------------------------------------------------------------------------------
+java-pkg_get-source() {
+ echo ${JAVA_PKG_WANT_SOURCE:-$(depend-java-query --get-lowest "${DEPEND} ${RDEPEND}")}
+}
+
+# ------------------------------------------------------------------------------
+# @ebuild-function java-pkg_get-target
+#
+# Determines what target version should be used, for passing to -target.
+# If you don't care about lower versions, you can set _WANT_TARGET to the
+# version of your JDK.
+# Remember doing this will mostly like cause things to break.
+# Doesn't allow it to be lower then the one in depend.
+# Doesn't allow it to be higher then the active vm.
+#
+# @return string - Either the lowest possible target, or JAVA_PKG_WANT_TARGET
+# ------------------------------------------------------------------------------
+java-pkg_get-target() {
+ local min=$(depend-java-query --get-lowest "${DEPEND} ${RDEPEND}")
+ if [[ -n "${JAVA_PKG_WANT_TARGET}" ]]; then
+ local max="$(java-config --select-vm "${GENTOO_VM}" -g PROVIDES_VERSION)"
+ if version_is_at_least "${min}" "${JAVA_PKG_WANT_TARGET}" && version_is_at_least "${JAVA_PKG_WANT_TARGET}" "${max}"; then
+ echo ${JAVA_PKG_WANT_TARGET}
+ else
+ echo ${min}
+ fi
+ else
+ echo ${min}
+ fi
+
+ #echo ${JAVA_PKG_WANT_TARGET:-$(depend-java-query --get-lowest "${DEPEND}")}
+}
+
+java-pkg_get-javac() {
+ debug-print-function ${FUNCNAME} $*
+
+ java-pkg_init-compiler_
+ local compiler="${GENTOO_COMPILER}"
+
+ local compiler_executable
+ if [[ "${compiler}" = "javac" ]]; then
+ # nothing fancy needs to be done for javac
+ compiler_executable="javac"
+ else
+ # for everything else, try to determine from an env file
+
+ local compiler_env="/usr/share/java-config-2/compiler/${compiler}"
+ if [[ -f ${compiler_env} ]]; then
+ local old_javac=${JAVAC}
+ unset JAVAC
+ # try to get value of JAVAC
+ compiler_executable="$(source ${compiler_env} 1>/dev/null 2>&1; echo ${JAVAC})"
+ export JAVAC=${old_javac}
+
+ [[ -z ${compiler_executable} ]] && die "JAVAC is empty or undefined in ${compiler_env}"
+
+ # check that it's executable
+ if [[ ! -x ${compiler_executable} ]]; then
+ eerror "Could not find ${compiler_executable}!"
+ die "${compiler_executable} doesn't exist, or isn't executable"
+ fi
+ else
+ eerror "Could not find environment file for ${compiler}"
+ die "Could not find ${compiler_env}"
+ fi
+ fi
+ echo ${compiler_executable}
+}
+
+# ------------------------------------------------------------------------------
+# @ebuild-function java-pkg_javac-args
+#
+# If an ebuild uses javac directly, instead of using ejavac, it should call this
+# to know what -source/-target to use.
+#
+# @return string - arguments to pass to javac, complete with -target and -source
+# ------------------------------------------------------------------------------
+java-pkg_javac-args() {
+ debug-print-function ${FUNCNAME} $*
+
+ local want_source="$(java-pkg_get-source)"
+ local want_target="$(java-pkg_get-target)"
+
+ local source_str="-source ${want_source}"
+ local target_str="-target ${want_target}"
+
+ debug-print "want source: ${want_source}"
+ debug-print "want target: ${want_target}"
+
+ if [[ -z "${want_source}" || -z "${want_target}" ]]; then
+ debug-print "could not find valid -source/-target values"
+ die "Could not find valid -source/-target values"
+ else
+ if java-pkg_is-vm-version-ge "1.4"; then
+ echo "${source_str} ${target_str}"
+ else
+ echo "${target_str}"
+ fi
+ fi
+}
+
+# TODO document
+java-pkg_get-jni-cflags() {
+ local flags="-I${JAVA_HOME}/include"
+
+ # TODO figure out how to cope with other things than linux...
+ flags="${flags} -I${JAVA_HOME}/include/linux"
+
+ echo ${flags}
+}
+
+# ------------------------------------------------------------------------------
+# @section-end helper
+# ------------------------------------------------------------------------------
+
+# ------------------------------------------------------------------------------
+# @section-begin build
+# @section-summary Build functions
+#
+# These are some functions for building a package. In particular, it consists of
+# wrappers for javac and ant.
+# ------------------------------------------------------------------------------
+
+# ------------------------------------------------------------------------------
+# @ebuild-function eant
+#
+# Ant wrapper function. Will use the appropriate compiler, based on user-defined
+# compiler.
+#
+# ------------------------------------------------------------------------------
+eant() {
+ debug-print-function ${FUNCNAME} $*
+
+ local antflags
+ java-pkg_init-compiler_
+ local compiler="${GENTOO_COMPILER}"
+
+ local compiler_env="${JAVA_PKG_COMPILER_DIR}/${compiler}"
+
+ local build_compiler="$(source ${compiler_env} 1>/dev/null 2>&1; echo ${ANT_BUILD_COMPILER})"
+ if [[ "${compiler}" != "javac" && -z "${build_compiler}" ]]; then
+ die "ANT_BUILD_COMPILER undefined in ${compiler_env}"
+ fi
+
+ if [[ ${compiler} != "javac" ]]; then
+ antflags="-Dbuild.compiler=${build_compiler}"
+ # Figure out any extra stuff to put on the classpath for compilers aside
+ # from javac
+ # ANT_BUILD_COMPILER_DEPS should be something that could be passed to
+ # java-config -p
+ local build_compiler_deps="$(source ${JAVA_PKG_COMPILER_DIR}/${compiler} 1>/dev/null 2>&1; echo ${ANT_BUILD_COMPILER_DEPS})"
+ if [[ -n ${build_compiler_deps} ]]; then
+ antflags="${antflags} -lib $(java-config -p ${build_compiler_deps})"
+ fi
+ fi
+
+ antflags="${antflags} -nouserlib -noclasspath"
+
+ if [[ -n ${JAVA_PKG_DEBUG} ]]; then
+ antflags="${antflags} -debug"
+ fi
+
+ [[ -n ${JAVA_PKG_DEBUG} ]] && echo ant ${antflags} "${@}"
+ ant ${antflags} "${@}" || die "eant failed"
+
+}
+
+# ------------------------------------------------------------------------------
+# @ebuild-function ejavac
+#
+# Javac wrapper function. Will use the appropriate compiler, based on
+# /etc/java-config/compilers.conf
+#
+# @param $@ - Arguments to be passed to the compiler
+# ------------------------------------------------------------------------------
+ejavac() {
+ debug-print-function ${FUNCNAME} $*
+
+ local compiler_executable=$(java-pkg_get-javac)
+
+ [[ -n ${JAVA_PKG_DEBUG} ]] && echo ${compiler_executable} $(java-pkg_javac-args) "${@}"
+ ${compiler_executable} $(java-pkg_javac-args) "${@}" || die "ejavac failed"
+}
+
+# ------------------------------------------------------------------------------
+# @ebuild-function java-pkg_filter-compiler
+#
+# Used to prevent the use of some compilers. Should be used in src_compile.
+# Basically, it just appends onto JAVA_PKG_FILTER_COMPILER
+#
+# @param $@ - compilers to filter
+# ------------------------------------------------------------------------------
+java-pkg_filter-compiler() {
+ JAVA_PKG_FILTER_COMPILER="${JAVA_PKG_FILTER_COMPILER} $@"
+}
+
+# ------------------------------------------------------------------------------
+# @ebuild-function use_doc
+#
+# Helper function for getting ant to build javadocs. If the user has USE=doc,
+# then 'javadoc' or the argument are returned. Otherwise, there is no return.
+#
+# The output of this should be passed to ant.
+#
+# Example: build javadocs by calling 'javadoc' target
+# eant $(use_doc)
+# Example: build javadocs by calling 'apidoc' target
+# eant $(use_doc apidoc)
+#
+# @param $@ - Option value to return. Defaults to 'javadoc'
+# @return string - Name of the target to create javadocs
+# ------------------------------------------------------------------------------
+use_doc() {
+ use doc && echo ${@:-javadoc}
+}
+
+# ------------------------------------------------------------------------------
+# @section-end build
+# ------------------------------------------------------------------------------
+
+# ------------------------------------------------------------------------------
+# @section-begin internal
+# @section-summary Internal functions
+#
+# Do __NOT__ use any of these from an ebuild! These are only to be used from
+# within the java eclasses.
+# ------------------------------------------------------------------------------
+
+# -----------------------------------------------------------------------------
+# @function-internal java-pkg_init
+#
+# The purpose of this function, as the name might imply, is to initialize the
+# Java environment. It ensures that that there aren't any environment variables
+# that'll muss things up. It initializes some variables, which are used
+# internally. And most importantly, it'll switch the VM if necessary.
+#
+# This shouldn't be used directly. Instead, java-pkg and java-pkg-opt will
+# call it during each of the phases of the merge process.
+#
+# -----------------------------------------------------------------------------
+java-pkg_init() {
+ unset JAVAC
+ unset JAVA_HOME
+ java-pkg_init_paths_
+ java-pkg_switch-vm
+ PATH=${JAVA_HOME}/bin:${PATH}
+
+ # TODO we will probably want to set JAVAC and JAVACFLAGS
+
+ # Do some QA checks
+ java-pkg_check-jikes
+
+ # When users have crazy classpaths some packages can fail to compile.
+ # and everything should work with empty CLASSPATH.
+ # This also helps prevent unexpected dependencies on random things
+ # from the CLASSPATH.
+ unset CLASSPATH
+}
+
+# ------------------------------------------------------------------------------
+# @function-internal java-pkg-init-compiler_
+#
+# This function attempts to figure out what compiler should be used. It does
+# this by reading the file at JAVA_PKG_COMPILERS_CONF, and checking the
+# COMPILERS variable defined there.
+# This can be overridden by a list in JAVA_PKG_FORCE_COMPILER
+#
+# It will go through the list of compilers, and verify that it supports the
+# target and source that are needed. If it is not suitable, then the next
+# compiler is checked. When JAVA_PKG_FORCE_COMPILER is defined, this checking
+# isn't done.
+#
+# Once the which compiler to use has been figured out, it is set to
+# GENTOO_COMPILER.
+#
+# If you hadn't guessed, JAVA_PKG_FORCE_COMPILER is for testing only.
+#
+# If the user doesn't defined anything in JAVA_PKG_COMPILERS_CONF, or no
+# suitable compiler was found there, then the default is to use javac provided
+# by the current VM.
+#
+#
+# @return name of the compiler to use
+# ------------------------------------------------------------------------------
+java-pkg_init-compiler_() {
+ debug-print-function ${FUNCNAME} $*
+
+ if [[ -n ${GENTOO_COMPILER} ]]; then
+ debug-print "GENTOO_COMPILER already set"
+ return
+ fi
+
+ local compilers="$(source ${JAVA_PKG_COMPILERS_CONF} 1>/dev/null 2>&1; echo ${COMPILERS})"
+ debug-print "Read \"${compilers}\" from ${JAVA_PKG_COMPILERS_CONF}"
+
+ # Figure out if we should announce what compiler we're using
+ local compiler
+ for compiler in ${compilers}; do
+ debug-print "Checking ${compiler}..."
+ # javac should always be alright
+ if [[ ${compiler} = "javac" ]]; then
+ debug-print "Found javac... breaking"
+ export GENTOO_COMPILER="javac"
+ break
+ fi
+
+ if has ${compiler} ${JAVA_PKG_FILTER_COMPILER}; then
+ if [[ -z ${JAVA_PKG_FORCE_COMPILER} ]]; then
+ einfo "Filtering ${compiler}"
+ continue
+ fi
+ fi
+
+ # for non-javac, we need to make sure it supports the right target and
+ # source
+ local compiler_env="${JAVA_PKG_COMPILER_DIR}/${compiler}"
+ if [[ -f ${compiler_env} ]]; then
+ local desired_target="$(java-pkg_get-target)"
+ local desired_source="$(java-pkg_get-source)"
+
+
+ # Verify that the compiler supports target
+ local supported_target=$(source ${compiler_env} 1>/dev/null 2>&1; echo ${SUPPORTED_TARGET})
+ if ! has ${desired_target} ${supported_target}; then
+ ewarn "${compiler} does not support -target ${desired_target}, skipping"
+ continue
+ fi
+
+ # -source was introduced in 1.3, so only check 1.3 and on
+ if version_is_at_least "${desired_soure}" "1.3"; then
+ # Verify that the compiler supports source
+ local supported_source=$(source ${compiler_env} 1>/dev/null 2>&1; echo ${SUPPORTED_SOURCE})
+ if ! has ${desired_source} ${supported_source}; then
+ ewarn "${compiler} does not support -source ${desired_source}, skipping"
+ continue
+ fi
+ fi
+
+ # if you get here, then the compiler should be good to go
+ export GENTOO_COMPILER="${compiler}"
+ break
+ else
+ ewarn "Could not find configuration for ${compiler}, skipping"
+ ewarn "Perhaps it is not installed?"
+ continue
+ fi
+ done
+
+ # If it hasn't been defined already, default to javac
+ if [[ -z ${GENTOO_COMPILER} ]]; then
+ if [[ -n ${compilers} ]]; then
+ einfo "No suitable compiler found: defaulting javac for compilation"
+ else
+ # probably don't need to notify users about the default.
+ :;#einfo "Defaulting to javac for compilation"
+ fi
+ export GENTOO_COMPILER=javac
+ else
+ einfo "Using ${GENTOO_COMPILER} for compilation"
+ fi
+
+}
+
+# ------------------------------------------------------------------------------
+# @internal-function init_paths_
+#
+# Initializes some variables that will be used. These variables are mostly used
+# to determine where things will eventually get installed.
+# ------------------------------------------------------------------------------
+java-pkg_init_paths_() {
+ debug-print-function ${FUNCNAME} $*
+
+ local pkg_name
+ if [[ "$SLOT" == "0" ]] ; then
+ JAVA_PKG_NAME="${PN}"
+ else
+ JAVA_PKG_NAME="${PN}-${SLOT}"
+ fi
+
+ JAVA_PKG_SHAREPATH="${DESTTREE}/share/${JAVA_PKG_NAME}"
+ JAVA_PKG_SOURCESPATH="${JAVA_PKG_SHAREPATH}/sources/"
+ JAVA_PKG_ENV="${D}${JAVA_PKG_SHAREPATH}/package.env"
+
+ [[ -z "${JAVA_PKG_JARDEST}" ]] && JAVA_PKG_JARDEST="${JAVA_PKG_SHAREPATH}/lib"
+ [[ -z "${JAVA_PKG_LIBDEST}" ]] && JAVA_PKG_LIBDEST="${DESTTREE}/$(get_libdir)/${JAVA_PKG_NAME}"
+ [[ -z "${JAVA_PKG_WARDEST}" ]] && JAVA_PKG_WARDEST="${JAVA_PKG_SHAREPATH}/webapps"
+
+
+ # TODO maybe only print once?
+ debug-print "JAVA_PKG_SHAREPATH: ${JAVA_PKG_SHAREPATH}"
+ debug-print "JAVA_PKG_ENV: ${JAVA_PKG_ENV}"
+ debug-print "JAVA_PKG_JARDEST: ${JAVA_PKG_JARDEST}"
+ debug-print "JAVA_PKG_LIBDEST: ${JAVA_PKG_LIBDEST}"
+ debug-print "JAVA_PKG_WARDEST: ${JAVA_PKG_WARDEST}"
+}
+
+# ------------------------------------------------------------------------------
+# @internal-function java-pkg_do_write_
+#
+# Writes the package.env out to disk.
+#
+# ------------------------------------------------------------------------------
+# TODO change to do-write, to match everything else
+java-pkg_do_write_() {
+ # Create directory for package.env
+ dodir "${JAVA_PKG_SHAREPATH}"
+ if [[ -n "${JAVA_PKG_CLASSPATH}" || -n "${JAVA_PKG_LIBRARY}" || -f "${JAVA_PKG_DEPEND}" ]]; then
+ # Create package.env
+ (
+ echo "DESCRIPTION=\"${DESCRIPTION}\""
+ echo "GENERATION=\"2\""
+
+ [[ -n "${JAVA_PKG_CLASSPATH}" ]] && echo "CLASSPATH=\"${JAVA_PKG_CLASSPATH}\""
+ [[ -n "${JAVA_PKG_LIBRARY}" ]] && echo "LIBRARY_PATH=\"${JAVA_PKG_LIBRARY}\""
+ [[ -n "${JAVA_PROVIDE}" ]] && echo "PROVIDES=\"${JAVA_PROVIDE}\""
+ [[ -f "${JAVA_PKG_DEPEND}" ]] && echo "DEPEND=\"$(cat ${JAVA_PKG_DEPEND} | uniq | tr '\n' ':')\""
+ echo "VM=\"$(echo ${RDEPEND} ${DEPEND} | sed -e 's/ /\n/g' | sed -n -e '/virtual\/\(jre\|jdk\)/ { p;q }')\"" # TODO cleanup !
+ ) > "${JAVA_PKG_ENV}"
+
+ # register target/source
+ local target="$(java-pkg_get-target)"
+ local source="$(java-pkg_get-source)"
+ [[ -n ${target} ]] && echo "TARGET=\"${target}\"" >> "${JAVA_PKG_ENV}"
+ [[ -n ${source} ]] && echo "SOURCE=\"${source}\"" >> "${JAVA_PKG_ENV}"
+
+ # register javadoc info
+ [[ -n ${JAVADOC_PATH} ]] && echo "JAVADOC_PATH=\"${JAVADOC_PATH}\"" \
+ >> ${JAVA_PKG_ENV}
+ # register source archives
+ [[ -n ${JAVA_SOURCES} ]] && echo "JAVA_SOURCES=\"${JAVA_SOURCES}\"" \
+ >> ${JAVA_PKG_ENV}
+
+
+ echo "MERGE_VM=\"${GENTOO_VM}\"" >> "${JAVA_PKG_ENV}"
+ [[ -n ${GENTOO_COMPILER} ]] && echo "MERGE_COMPILER=\"${GENTOO_COMPILER}\"" >> "${JAVA_PKG_ENV}"
+
+ # Strip unnecessary leading and trailing colons
+ # TODO try to cleanup if possible
+ sed -e "s/=\":/=\"/" -e "s/:\"$/\"/" -i "${JAVA_PKG_ENV}" || die "Did you forget to call java_init ?"
+ fi
+}
+
+
+# ------------------------------------------------------------------------------
+# @internal-function java-pkg_record-jar_
+#
+# Record a dependency to the package.env
+#
+# ------------------------------------------------------------------------------
+JAVA_PKG_DEPEND="${T}/java-pkg-depend"
+
+java-pkg_record-jar_() {
+ debug-print-function ${FUNCNAME} $*
+
+ local pkg=${1} jar=${2} append
+ if [[ -z "${jar}" ]]; then
+ append="${pkg}"
+ else
+ append="$(basename ${jar})@${pkg}"
+ fi
+
+ echo ${append} >> ${JAVA_PKG_DEPEND}
+}
+
+# ------------------------------------------------------------------------------
+# @internal-function java-pkg_append_
+#
+# Appends a value to a variable
+#
+# Example: java-pkg_append_ CLASSPATH foo.jar
+# @param $1 variable name to modify
+# @param $2 value to append
+# ------------------------------------------------------------------------------
+java-pkg_append_() {
+ debug-print-function ${FUNCNAME} $*
+
+ local var="${1}" value="${2}"
+ if [[ -z "${!var}" ]] ; then
+ export ${var}="${value}"
+ else
+ local oldIFS=${IFS} cur haveit
+ IFS=':'
+ for cur in ${!var}; do
+ if [[ ${cur} == ${value} ]]; then
+ haveit="yes"
+ break
+ fi
+ done
+ [[ -z ${haveit} ]] && export ${var}="${!var}:${value}"
+ IFS=${oldIFS}
+ fi
+}
+
+# ------------------------------------------------------------------------------
+# @internal-function java-pkg_expand_dir_
+#
+# Gets the full path of the file/directory's parent.
+# @param $1 - file/directory to find parent directory for
+# @return - path to $1's parent directory
+# ------------------------------------------------------------------------------
+java-pkg_expand_dir_() {
+ pushd "$(dirname "${1}")" >/dev/null 2>&1
+ pwd
+ popd >/dev/null 2>&1
+}
+
+# ------------------------------------------------------------------------------
+# @internal-function java-pkg_func-exists
+#
+# Does the indicated function exist?
+#
+# @return 0 - function is declared
+# @return 1 - function is undeclared
+# ------------------------------------------------------------------------------
+java-pkg_func-exists() {
+ if [[ -n "$(declare -f ${1})" ]]; then
+ return 0
+ else
+ return 1
+ fi
+}
+
+# ------------------------------------------------------------------------------
+# @internal-function java-pkg_setup-vm
+#
+# Sets up the environment for a specific VM
+#
+# ------------------------------------------------------------------------------
+java-pkg_setup-vm() {
+ debug-print-function ${FUNCNAME} $*
+
+ local vendor="$(java-pkg_get-vm-vendor)"
+ if [[ "${vendor}" == "sun" ]] && java-pkg_is-vm-version-ge 1 5; then
+ addpredict "/dev/random"
+ elif [[ "${vendor}" == "ibm" ]]; then
+ addpredict "/proc/self/maps"
+ addpredict "/proc/cpuinfo"
+ export LANG="C" LC_ALL="C"
+ elif [[ "${vendor}" == "jrockit" ]]; then
+ addpredict "/proc/cpuinfo"
+ fi
+}
+
+# ------------------------------------------------------------------------------
+# @internal-function java-pkg_needs-vm
+#
+# Does the current package depend on virtual/jdk?
+#
+# @return 0 - Package depends on virtual/jdk
+# @return 1 - Package does not depend on virtual/jdk
+# ------------------------------------------------------------------------------
+java-pkg_needs-vm() {
+ debug-print-function ${FUNCNAME} $*
+
+ if [[ -n "$(echo ${DEPEND} | sed -e '\:virtual/jdk:!d')" ]]; then
+ return 0
+ fi
+
+ return 1
+}
+
+# ------------------------------------------------------------------------------
+# @internal-function java-pkg_get-current-vm
+#
+# @return - The current VM being used
+# ------------------------------------------------------------------------------
+java-pkg_get-current-vm() {
+ java-config -f
+}
+
+# ------------------------------------------------------------------------------
+# @internal-function java-pkg_get-vm-vendor
+#
+# @return - The vendor of the current VM
+# ------------------------------------------------------------------------------
+java-pkg_get-vm-vendor() {
+ debug-print-function ${FUNCNAME} $*
+
+ local vm="$(java-pkg_get-current-vm)"
+ vm="${vm/-*/}"
+ echo "${vm}"
+}
+
+# ------------------------------------------------------------------------------
+# @internal-function java-pkg_get-vm-version
+#
+# @return - The version of the current VM
+# ------------------------------------------------------------------------------
+java-pkg_get-vm-version() {
+ debug-print-function ${FUNCNAME} $*
+
+ java-pkg_get-current-vm | sed -e "s/.*-\([0-9.]\+\).*/\1/"
+}
+
+# ------------------------------------------------------------------------------
+# @internal-function java-pkg_switch-vm
+#
+# Switch VM if we're allowed to (controlled by JAVA_PKG_ALLOW_VM_CHANGE), and
+# verify that the current VM is sufficient.
+# Setup the environment for the VM being used.
+# ------------------------------------------------------------------------------
+java-pkg_switch-vm() {
+ if java-pkg_needs-vm; then
+ # Use the VM specified by JAVA_PKG_FORCE_VM
+ if [[ -n ${JAVA_PKG_FORCE_VM} ]]; then
+ # If you're forcing the VM, I hope you know what your doing...
+ export GENTOO_VM="${JAVA_PKG_FORCE_VM}"
+ # if we're allowed to switch the vm...
+ elif [[ "${JAVA_PKG_ALLOW_VM_CHANGE}" == "yes" ]]; then
+ debug-print "depend-java-query: NV_DEPEND: ${JAVA_PKG_NV_DEPEND:-${DEPEND}} VNEED: ${JAVA_PKG_VNEED}"
+ if [[ -n ${JAVA_PKG_VNEED} ]]; then
+ export GENTOO_VM="$(depend-java-query --need-virtual "${JAVA_PKG_VNEED}" --get-vm "${JAVA_PKG_NV_DEPEND:-${DEPEND}}")"
+ else
+ export GENTOO_VM="$(depend-java-query --get-vm "${JAVA_PKG_NV_DEPEND:-${DEPEND}}")"
+ fi
+ # otherwise just make sure the current VM is sufficient
+ else
+ java-pkg_ensure-vm-version-sufficient
+ fi
+ debug-print "Using: $(java-config -f)"
+
+ java-pkg_setup-vm
+
+ export JAVACFLAGS="$(java-pkg_javac-args)"
+ [[ -n ${JAVACFLAGS_EXTRA} ]] && export JAVACFLAGS="${JAVACFLAGS_EXTRA} ${JAVACFLAGS}"
+
+ export JAVA_HOME="$(java-config -g JAVA_HOME)"
+ export JDK_HOME=${JAVA_HOME}
+
+ #TODO If you know a better solution let us know.
+ java-pkg_append_ LD_LIBRARY_PATH "$(java-config -g LDPATH)"
+
+ local tann="${T}/announced-vm"
+ if [[ -n "${JAVA_PKG_DEBUG}" ]] || [[ ! -f "${tann}" ]] ; then
+ # Add a check for setup/preinst phase... to avoid duplicate outputs
+ # for when FEATURES=buildpkg
+ if [[ ${EBUILD_PHASE} != "setup" && ${EBUILD_PHASE} != "preinst" && ${EBUILD_PHASE} != "postinst" ]];
+ then
+ einfo "Using: $(java-config -f)"
+ [[ ! -f "${tann}" ]] && touch "${tann}"
+ fi
+ fi
+
+ else
+ [[ -n "${JAVA_PKG_DEBUG}" ]] && ewarn "!!! This package inherits java-pkg but doesn't depend on a JDK. -bin or broken dependency!!!"
+ fi
+}
+
+# ------------------------------------------------------------------------------
+# @internal-function java-pkg_die
+#
+# Enhanced die for Java packages, which displays some information that may be
+# useful for debugging bugs on bugzilla.
+# ------------------------------------------------------------------------------
+#register_die_hook java-pkg_die
+if ! hasq java-pkg_die ${EBUILD_DEATH_HOOKS}; then
+ EBUILD_DEATH_HOOKS="${EBUILD_DEATH_HOOKS} java-pkg_die"
+fi
+
+java-pkg_die() {
+ echo "!!! When you file a bug report, please include the following information:" >&2
+ echo "GENTOO_VM=${GENTOO_VM} CLASSPATH=\"${CLASSPATH}\" JAVA_HOME=\"${JAVA_HOME}\"" >&2
+ echo "JAVACFLAGS=\"${JAVACFLAGS}\" COMPILER=\"${GENTOO_COMPILER}\"" >&2
+ echo "and of course, the output of emerge --info" >&2
+}
+
+# ------------------------------------------------------------------------------
+# @section-end internal
+# ------------------------------------------------------------------------------
+
+java-pkg_check-phase() {
+ local phase=${1}
+ local funcname=${2}
+ # TODO add check for java-stricter
+ if [[ ${EBUILD_PHASE} != ${phase} ]]; then
+ java-pkg_announce-qa-violation \
+ "${funcname} used outside of src_${phase}"
+ fi
+}
+
+java-pkg_check-versioned-jar() {
+ local jar=${1}
+
+ if [[ ${jar} =~ ${PV} ]]; then
+ java-pkg_announce-qa-violation "installing versioned jar '${jar}'"
+ fi
+}
+
+java-pkg_check-jikes() {
+ if hasq jikes ${IUSE}; then
+ java-pkg_announce-qa-violation "deprecated USE flag 'jikes' in IUSE"
+ fi
+}
+
+java-pkg_announce-qa-violation() {
+ if hasq java-strict ${FEATURES}; then
+ echo "Java QA Notice: $@" >&2
+ increment-qa-violations
+ fi
+}
+
+increment-qa-violations() {
+ let "JAVA_PKG_QA_VIOLATIONS+=1"
+ export JAVA_PKG_QA_VIOLATIONS
+}
+
+# ------------------------------------------------------------------------------
+# @eclass-end
+# ------------------------------------------------------------------------------
diff --git a/eclass/java-utils.eclass b/eclass/java-utils.eclass
index 51e7a4eb03d7..3fc820f0c2a4 100644
--- a/eclass/java-utils.eclass
+++ b/eclass/java-utils.eclass
@@ -11,7 +11,11 @@ inherit eutils
DESCRIPTION="Based on the $ECLASS eclass"
-DEPEND=">=dev-java/java-config-1.2.7"
+JAVA_CONFIG_DEP="|| ( =dev-java/java-config-1.3* =dev-java/java-config-1.2* )"
+DEPEND="${JAVA_CONFIG_DEP}"
+RDEPEND="${JAVA_CONFIG_DEP}"
+
+export WANT_JAVA_CONFIG="1"
EXPORT_FUNCTIONS pkg_setup
diff --git a/eclass/java-vm-2.eclass b/eclass/java-vm-2.eclass
new file mode 100644
index 000000000000..2a50d2372de3
--- /dev/null
+++ b/eclass/java-vm-2.eclass
@@ -0,0 +1,149 @@
+# Copyright 1999-2004 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: /var/cvsroot/gentoo-x86/eclass/java-vm-2.eclass,v 1.1 2006/06/24 18:36:59 nichoj Exp $
+#
+# Author: Karl Trygve Kalleberg <karltk@gentoo.org>
+
+inherit eutils
+
+DEPEND="
+ =dev-java/java-config-2.0*
+ =dev-java/java-config-1.3*"
+RDEPEND="
+ =dev-java/java-config-2.0*
+ =dev-java/java-config-1.3*"
+
+export WANT_JAVA_CONFIG=2
+
+if [[ "${SLOT}" != "0" ]]; then
+ VMHANDLE=${PN}-${SLOT}
+else
+ VMHANDLE=${PN}
+fi
+
+JAVA_VM_CONFIG_DIR="/usr/share/java-config-2/vm"
+JAVA_VM_DIR="/usr/lib/jvm"
+
+EXPORT_FUNCTIONS pkg_postinst pkg_prerm
+
+java-vm-2_pkg_postinst() {
+ # Set the generation-2 system VM, if it isn't set
+ if [[ -z "$(java-config-2 -f)" ]]; then
+ java_set_default_vm_
+ fi
+
+ if [[ ${JAVA_VM_NO_GENERATION1} != "true" ]]; then
+ local systemvm1="$(java-config-1 -f)"
+ # no generation-1 system-vm was yet set
+ if [[ -z "${systemvm1}" ]]; then
+ einfo "No valid generation-1 system-vm set, setting to ${P}"
+ java-config-1 --set-system-vm=${P}
+ # dirty check to see if we are upgrading current generation-1 system vm
+ elif [[ ${systemvm1} =~ "^${VMHANDLE}" ]]; then
+ einfo "Upgrading generation-1 system-vm... updating its env file"
+ java-config-1 --set-system-vm=${P}
+ fi
+ # else... some other VM is being updated, so we don't have to worry
+ fi
+
+ java_mozilla_clean_
+}
+
+java-vm-2_pkg_prerm() {
+ if [[ "$(java-config -f)" == "${VMHANDLE}" ]]; then
+ ewarn "It appears you are removing your default system VM!"
+ ewarn "Please run java-config -L then java-config -S to set a new system VM!"
+ fi
+}
+
+java_set_default_vm_() {
+ java-config-2 --set-system-vm="${VMHANDLE}"
+
+ einfo " After installing ${P} this"
+ einfo " was set as the default JVM to run."
+}
+
+get_system_arch() {
+ local sarch
+ sarch=$(echo ${ARCH} | sed -e s/[i]*.86/i386/ -e s/x86_64/amd64/ -e s/sun4u/sparc/ -e s/sparc64/sparc/ -e s/arm.*/arm/ -e s/sa110/arm/)
+ if [ -z "${sarch}" ]; then
+ sarch=$(uname -m | sed -e s/[i]*.86/i386/ -e s/x86_64/amd64/ -e s/sun4u/sparc/ -e s/sparc64/sparc/ -e s/arm.*/arm/ -e s/sa110/arm/)
+ fi
+ echo ${sarch}
+}
+
+# TODO rename to something more evident, like install_env_file
+set_java_env() {
+ local platform="$(get_system_arch)"
+ local env_file="${D}${JAVA_VM_CONFIG_DIR}/${VMHANDLE}"
+ local old_env_file="${D}/etc/env.d/java/20${P}"
+ local source_env_file="${FILESDIR}/${VMHANDLE}"
+
+ if [[ ! -f ${source_env_file} ]]; then
+ die "Unable to find the env file: ${source_env_file}"
+ fi
+
+ dodir ${JAVA_VM_CONFIG_DIR}
+ dodir /etc/env.d/java # generation-1 compatibility
+ sed \
+ -e "s/@P@/${P}/g" \
+ -e "s/@PN@/${PN}/g" \
+ -e "s/@PV@/${PV}/g" \
+ -e "s/@PF@/${PF}/g" \
+ -e "s/@PLATFORM@/${platform}/g" \
+ -e "/^LDPATH=.*lib\\/\\\"/s|\"\\(.*\\)\"|\"\\1${platform}/:\\1${platform}/server/\"|" \
+ < ${source_env_file} \
+ > ${env_file} || die "sed failed"
+
+ echo "VMHANDLE=\"${VMHANDLE}\"" >> ${env_file}
+
+ # generation-1 compatibility
+ if [[ ${JAVA_VM_NO_GENERATION1} != true ]]; then
+ # We need to strip some things out of the new style env,
+ # because these end up going in the env
+ sed -e 's/.*CLASSPATH.*//' \
+ -e 's/.*PROVIDES.*//' \
+ ${env_file} \
+ > ${old_env_file} || die "failed to create old-style env file"
+ fi
+
+ [[ -n ${JAVA_PROVIDE} ]] && echo "PROVIDES=\"${JAVA_PROVIDE}\"" >> ${env_file}
+
+ local java_home=$(source ${env_file}; echo ${JAVA_HOME})
+ [[ -z ${java_home} ]] && die "No JAVA_HOME defined in ${env_file}"
+
+ # Make the symlink
+ dosym ${java_home} ${JAVA_VM_DIR}/${VMHANDLE} \
+ || die "Failed to make VM symlink at ${JAVA_VM_DIR}/${VMHANDE}"
+}
+
+
+java_get_plugin_dir_() {
+ echo /usr/$(get_libdir)/nsbrowser/plugins
+}
+
+install_mozilla_plugin() {
+ local plugin=${1}
+
+ if [ ! -f "${D}/${plugin}" ] ; then
+ die "Cannot find mozilla plugin at ${D}/${plugin}"
+ fi
+
+ local plugin_dir=$(java_get_plugin_dir_)
+ dodir ${plugin_dir}
+ dosym ${plugin} ${plugin_dir}/javaplugin.so
+}
+
+java_mozilla_clean_() {
+ # Because previously some ebuilds installed symlinks outside of pkg_install
+ # and are left behind, which forces you to manualy remove them to select the
+ # jdk/jre you want to use for java
+ local plugin_dir=$(java_get_plugin_dir_)
+ for file in ${plugin_dir}/javaplugin_*; do
+ rm -f ${file}
+ done
+ for file in ${plugin_dir}/libjavaplugin*; do
+ rm -f ${file}
+ done
+}
+
diff --git a/eclass/java.eclass b/eclass/java.eclass
index 2ae31967ae4b..fdb1b286367a 100644
--- a/eclass/java.eclass
+++ b/eclass/java.eclass
@@ -1,15 +1,18 @@
# Copyright 1999-2004 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
-# $Header: /var/cvsroot/gentoo-x86/eclass/java.eclass,v 1.29 2006/02/17 22:18:20 swegener Exp $
+# $Header: /var/cvsroot/gentoo-x86/eclass/java.eclass,v 1.30 2006/06/24 18:36:59 nichoj Exp $
#
# Author: Karl Trygve Kalleberg <karltk@gentoo.org>
inherit eutils
DESCRIPTION="Based on the $ECLASS eclass"
-DEPEND=">=dev-java/java-config-1.2.11
+JAVA_CONFIG_DEP="|| ( =dev-java/java-config-1.3* =dev-java/java-config-1.2* )"
+DEPEND="${JAVA_CONFIG_DEP}
sys-apps/findutils"
-RDEPEND=">=dev-java/java-config-1.2.11"
+RDEPEND="${JAVA_CONFIG_DEP}"
+
+export WANT_JAVA_CONFIG="1"
VMHANDLE=${PN}-${PV}
@@ -116,7 +119,7 @@ java_remove-libjsoundalsa() {
fi
}
-# Symlinks i386 to i?86. Updates env file to then use i?86
+# Symlinks i386 to i?86. Updates env file to then use i?86
# for LD_LIBRARY_PATH. See bug #23579.
#
# Takes an argument, which is a directory living in ${D}
@@ -128,12 +131,12 @@ fix-i386-dir() {
if use x86; then
local host=${CTARGET:-${CHOST}}
host=${host%%-*}
-
+
if [[ ${host} != i386 ]]; then
local orig_dir="${libdir}/i386"
local new_dir="${libdir}/${host}"
dosym i386 ${new_dir} || die "Failed to dosym"
-
+
sed -i -e "s/i386/${host}/g" \
${D}/etc/env.d/java/20${VMHANDLE} || die "Failed to sed"